/**
This is the other difference between an array and a pointer (besides the array being const):
The length of the array is hidden from you (but it still exsts) for an array, but not for a pointer.
Arrays degrade to pointers when passed to functions.
**/

#include <iostream>
using std::cout;
using std::endl;

void getAverage(int arrayIn[])
{
    cout << "Size of the whole array is: "
         << sizeof(arrayIn) << endl;

    cout << "Size of one element of the array is: "
         << sizeof(arrayIn[0]) << endl;

    cout << "The ratio of the two gives you the number of elements in the array: "
         << sizeof(arrayIn) / sizeof(arrayIn[0]) << endl;
}

int main()
{
    int myArray[12];

    cout << "ARRAY \nThe length of the array is available outside the function: "
         << sizeof(myArray) / sizeof(myArray[0]) << endl << endl;

    cout << "but not inside: " << endl;
    getAverage(myArray);
    cout << endl;



    int *mypointer;
    mypointer = new int[12];

    cout << "\n\nPOINTER \nThe length of an array pointed to by a pointer never is: "
         << sizeof(mypointer) / sizeof(mypointer[0]) << endl << endl;

    getAverage(mypointer);

    return 0;
}
